org.apache.ignite.internal.util.io

## Class GridReversedLinesFileReader

- java.lang.Object
- - org.apache.ignite.internal.util.io.GridReversedLinesFileReader

All Implemented Interfaces:
  Closeable, AutoCloseable

    public class GridReversedLinesFileReader
    extends Object
    implements Closeable

Reads lines in a file reversely (similar to a BufferedReader, but starting at the last line). Useful for e.g. searching in log files.

### Constructor Summary

Constructors
Constructor and Description
`GridReversedLinesFileReader(File file)` Creates a ReverseLineReader with default block size of 4KB and the platform's default encoding.
`GridReversedLinesFileReader(File file, int blockSize, Charset charset)` Creates a ReverseLineReader with the given block size and encoding.
`GridReversedLinesFileReader(File file, int blockSize, String encoding)` Creates a ReverseLineReader with the given block size and encoding.

### Method Summary

Methods
`void` `close()` Closes underlying resources.
`String` `readLine()` Returns the lines of the file from bottom to top.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### GridReversedLinesFileReader

    public GridReversedLinesFileReader(File file)
                                throws IOException

Creates a ReverseLineReader with default block size of 4KB and the platform's default encoding.

Parameters:
  `file` - the file to be read
Throws:
  `IOException` - if an I/O error occurs

#### GridReversedLinesFileReader

    public GridReversedLinesFileReader(File file,
                               int blockSize,
                               Charset charset)
                                throws IOException

Creates a ReverseLineReader with the given block size and encoding.

Parameters:
  `file` - the file to be read
  `blockSize` - size of the internal buffer (for ideal performance this should match with the block size of the underlying file system).
  `charset` - the encoding of the file
Throws:
  `IOException` - if an I/O error occurs
Since:
  2.3

#### GridReversedLinesFileReader

    public GridReversedLinesFileReader(File file,
                               int blockSize,
                               String encoding)
                                throws IOException

Creates a ReverseLineReader with the given block size and encoding.

Parameters:
  `file` - the file to be read
  `blockSize` - size of the internal buffer (for ideal performance this should match with the block size of the underlying file system).
  `encoding` - the encoding of the file
Throws:
  `IOException` - if an I/O error occurs
  `UnsupportedCharsetException` - thrown instead of `UnsupportedEncodingException` in version 2.2 if the encoding is not supported.

### Method Detail

#### readLine

    public String readLine()
                    throws IOException

Returns the lines of the file from bottom to top.

Returns:
  the next line or null if the start of the file is reached
Throws:
  `IOException` - if an I/O error occurs

#### close

    public void close()
               throws IOException

Closes underlying resources.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Throws:
  `IOException` - if an I/O error occurs

2017 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.9.0
Release Date | : March 2 2017